<?php defined( 'ABSPATH' ) or die( __('No script kiddies please!', 'wc-order-split') );
	if ( !current_user_can( 'administrator' ) ) {
		wp_die( __( 'You do not have sufficient permissions to access this page.', 'wc-order-split' ) );
	}
	global $wcos_data, $wcos_pro, $wcos_premium_link;
	$successfully_saved = false;

	if(isset($_GET['order_id'])){
		$order_id = sanitize_wcos_data($_GET['order_id']);
		$order_data = wc_get_order( $order_id );
	
	}else{
		wp_redirect(admin_url().'edit.php?post_type=shop_order');
	}
	$colors = admin_url().'admin.php?page=wcos_colors';		
			
	if(isset($_POST['submit_form'])){
		
		if ( ! isset( $_POST['wcos_order_split_field'] ) 
			|| ! wp_verify_nonce( $_POST['wcos_order_split_field'], 'wcos_order_split_action' ) 
		) {
		   print 'Sorry, your nonce did not verify.';
		   exit;
		} else {
		   // process form data
		   //pree($_POST);
		   if(isset($_POST['grouping'])){
			   $user_id = $order_data->get_user_id();
			   $new_order_ids = array();
			   //pree($user_id);exit;
			   foreach($_POST['grouping'] as $group=>$items){
				   if(in_array($group, array('default'))){ continue; }
				   //pree($group);
				   //pree($items);
				   $order_data_arr =  array(
						'post_type'     => 'shop_order',
						'post_status'   => 'publish',
						'ping_status'   => 'closed',
						'post_author'   => $user_id,
						'post_password' => uniqid( 'order_' ),
					);
				
					$split_order_id = wp_insert_post( apply_filters( 'woocommerce_new_order_data', $order_data_arr), true );
					
					//wc_os_pree($order_data);exit;
					
					//wc_os_pree('order_id:'.$order_id);
			
					if ( is_wp_error( $split_order_id ) ) {	
						//add_action( 'admin_notices', array($this, 'clone__error'));
					} else {
						
						update_post_meta($split_order_id, 'split_status', true);
						update_post_meta($split_order_id, 'split_group', $group);
						update_post_meta($split_order_id, 'cloned_from', $order_id);
						$new_order_ids[] = $split_order_id;
						$split_items = array_keys($items);
						wcos_split_order($split_order_id, $order_id, $split_items);
						
					}	
			   }
			   $successfully_saved = true;
		   }
		   //exit;
		   //pree($_POST);exit;
		}		
		
	}

	
	

	$arg = get_option('wcos_colors', array());
	$all_classes = (is_array($arg)?$arg:array());
	if(!empty($all_classes)){
		foreach ($all_classes as $classes) {
			list($name, $bg, $color, $class) = $classes;
			$class_arr[] = esc_html($class);
		}
	}
	if(!empty($class_arr)){
		echo '<style type="text/css">'.implode(' ', $class_arr).'</style>';
	}
?>
<div class="container-fluid wcos_wrapper_div pt-4">
		<div class="row mb-4">
        	<div class="icon32" id="icon-options-general"><br></div><h4><?php echo $wcos_data['Name']; ?> <?php echo '('.$wcos_data['Version'].($wcos_pro?') Pro':')'); ?> - <?php _e("Order","wc-order-split"); ?> <?php _e("Management","wc-order-split"); ?> </h4> 
            <?php if(!$wcos_pro): ?>
            <a href="<?php echo $wcos_premium_link; ?>" target="_blank" class="btn btn-info btn-sm" style="position:absolute; right:15px">Go Premium</a>
            <?php endif; ?>
        </div>
<?php if($successfully_saved):  ?>
        <div class="row">
            <div class="alert alert-success">
            <strong>Success!</strong> Order splitted successfully.
            </div>
        </div>
<?php if(isset($_POST['wcos_remove_selected']) && $_POST['wcos_remove_selected']==1): ?>        
<script type="text/javascript" language="javascript">
jQuery(document).ready(function($) {
	setTimeout(function(){
		document.location.reload();
	}, 2000);
});
</script>        
<?php endif; ?>
<?php endif; ?>

		<div class="row">
			<div class="col-md-9 pl-0">
			<form method="post">
			<?php wp_nonce_field( 'wcos_order_split_action', 'wcos_order_split_field' ); ?>
        
		<ul class="list-group wcos_order_items">
       
			<?php 
			if(!empty($order_data->get_items())){
						foreach( $order_data->get_items() as $item_key => $item_values ){

							$item = $item_values->get_data();
							//pree($item);
				?>
			<li class="list-group-item li-Item default" data-id="<?php echo $item['product_id'];?>">
			<?php echo $item['name'].'_________&times;'.$item['quantity'];?>
            <input type="hidden" name="grouping[default][<?php echo $item['product_id'];?>]">
            </li>			

			<?php } } ?>
			</ul>
            
            <div class="form-group mt-4 wcos_extra_features">                
                <div class="checkbox <?php echo $wcos_pro?'':'disabled'; ?>">
                  <label><input type="checkbox" value="1" name="wcos_remove_selected" <?php echo $wcos_pro?'':'disabled'; ?> />Remove selected items from this order / after split</label>
                </div>
            </div>
 <?php if(count($order_data->get_items())<=1):  ?>
        <div class="form-group float-left mt-3">
            <div class="alert alert-warning">
            <strong>Warning!</strong> This order has not enough items to split further.
            </div>
        </div>
<?php elseif(!empty($all_classes)): ?>           
            
            <div class="form-group mt-3">
				<button type="submit" class="btn btn-primary form-control btn-sm" name="submit_form" style="width:200px;">Proceed to Split</button>
            </div>
            

<?php endif; ?>            
		</form>
        
<?php if(count($order_data->get_items())>1):  ?>    
<?php if(!empty($all_classes)): ?>  
            <div class="col-md-9 pl-0">
            
			<div class="alert alert-info">
           	<strong>Info!</strong> You can choose any group label and then select items to split in a new order.
            </div>            
            <div class="alert alert-warning">
			<strong>Warning!</strong> In case you don't select any group label, still it will automatically pick the first label.
            </div> 
            </div>    
<?php else: ?>
			<div class="col-md-9 pl-0 mt-3">			           
            <div class="alert alert-danger">
			<strong>Required!</strong> Please define at least one group label. <a href="<?php echo $colors; ?>" target="_blank">Click here</a> to define a group label.
            </div> 
            </div>
<?php endif; ?>               
<?php endif; ?>         
		</div>

		<div class="col-md-3">
		
		<ul class="list-group wcos_order_groups w-100">
        <li class="list-group-item text-center"><a class="btn btn-warning btn-sm" href="<?php echo $colors; ?>" target="_blank">Define Group Labels</a></li>
	<?php 
		if(!empty($all_classes)){
			foreach ($all_classes as $classes) {
				list($name, $bg, $color, $class) = $classes; 
					
	?>
				<li data-class="<?php echo esc_html($name);?>" class="list-group-item <?php echo esc_html($name);?> liSelection w-100"><?php echo esc_html($name);?></li>
		
	<?php } } ?>
			
		</ul>
        <li class="list-group-item text-center"><a href="https://www.youtube.com/embed/gocz4OdSOkw" target="_blank" class="btn btn-warning btn-sm">How it works?</a></li>
            
			

		</div>

		</div>
        
        <div class="row">
<?php 
		$arr = array(
			'numberposts' => -1,
			'post_type' => 'shop_order',
			'post_status' => 'any',
			'meta_key' => 'cloned_from',
			'meta_value' => $order_id
		);
		//pree($arr);
		$all_orders = get_posts($arr);
		//pree($all_orders);
		if(!empty($all_orders)){
?>        
        <div class="col-md-12 pl-0">
        <h5>Splitted Orders</h5>
        </div>
        <div class="col-md-12 pl-0">

        <ul class="list-group wcos_orders">
<?php 
		foreach($all_orders as $orders){
?>
		<li class="list-group-item" data-id="<?php echo $orders->ID;?>">
        <a href="<?php echo admin_url(); ?>post.php?post=<?php echo $orders->ID;?>&action=edit" target="_blank">#<?php echo $orders->ID;?></a>
        <span class="<?php echo esc_html(get_post_meta($orders->ID, 'split_group', true)); ?>"></span>
        </li>
<?php			
		}
?>		
        </ul>
        </div>
<?php 
		}
?>		
</div>

		
</div>